## siconos 4.2.0+git20181026.0ee5349+dfsg.2

=== CMakeLists.txt ===
#===============================================================================
# cmake utility to compile and install siconos.
#
#
# Siconos development team - September 2015.
#
#===============================================================================

# ============= Global 'standard' cmake Settings =============

# Set minimum version for cmake
cmake_minimum_required(VERSION 3.0.2)

# Set cmake modules directory (i.e. the one which contains all user-defined FindXXX.cmake files among other things)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# Force out-of-source build
include(OutOfSourcesBuild)

# Some useful macros
include(SiconosTools)
configure_file(scripts/buildtools.py share/buildtools.py COPYONLY)

# cmake project name
set(PROJECT_NAME siconos)
set(PROJECT_NAME_CAP Siconos)


# Get current year (for licence and other cartridges)
execute_process(COMMAND date "+\"%Y\"" OUTPUT_VARIABLE YEAR)
string(STRIP ${YEAR} YEAR)
if(USER_OPTIONS_FILE)
  get_filename_component(input_file ${USER_OPTIONS_FILE} NAME)
  get_filename_component(path_to_file ${USER_OPTIONS_FILE} PATH)
  find_file(filefound NAMES ${input_file}
    PATHS ${path_to_file} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}
    )
  if(NOT ${filefound}-NOTFOUND)
    configure_file(${path_to_file}/${input_file} ${CMAKE_SOURCE_DIR}/${input_file})
  else()
    message(FATAL_ERROR "Cannot find file ${USER_OPTIONS_FILE}")
  endif()
  message("\n !!!!! Load user-defined options set from file ${filefound} !!!!! \n")
  include(${input_file})
  # copy user file to binary dir, just for 'visual' check.
  configure_file(${input_file} ${input_file} COPYONLY)
  assert(WITH_FORTRAN "The option WITH_FORTRAN is not defined in the user options file")
else()
  include(default_options)
endif()

# Set target names from components list
assert(COMPONENTS)
set(AVAILABLE_COMPONENTS "externals numerics kernel control mechanics mechanisms io")
foreach(component_name ${COMPONENTS})
  string(TOUPPER ${component_name} upname)
  list(FIND ${AVAILABLE_COMPONENTS} ${component_name} comp_exists)
  if(NOT comp_exists)
    message(FATAL_ERROR "Unknown siconos component : ${component_name}")
  endif()
  set(HAVE_SICONOS_${upname} TRUE)
endforeach()

# ============= The project =============
# Set project name and project languages
# => this automatically defines:
#   - ${PROJECT_NAME}_BINARY_DIR : where you have run cmake, i.e. the place for compilation
#   - ${PROJECT_NAME}_SOURCE_DIR : where sources (.f and .h and this CMakeLists.txt) are located
# Note that because of OutOfSourceBuild, binary_dir and source_dir must be different.
if(WITH_CXX)
  if (WITH_FORTRAN)
    project(${PROJECT_NAME} CXX C Fortran)
    # Fortran compiler configuration
    include(FCompilerSetup)
    set(HAS_FORTRAN TRUE)
  else()
    project(${PROJECT_NAME} CXX C)
    #unset(HAS_FORTRAN)
  endif()
   # Set CXX compilation flags
  include(CXXCompilerSetup)
else()
  # we may need to compile only numerics and only in C.
  if (WITH_FORTRAN)
    project(${PROJECT_NAME} C Fortran)
    # Fortran compiler configuration
    include(FCompilerSetup)
    set(HAS_FORTRAN TRUE)
  else()
    project(${PROJECT_NAME} C)
    #unset(HAS_FORTRAN)
  endif()
endif()

# Set C compilation flags
include(CCompilerSetup)

# Common setup
include(SiconosSetup)

# ========= Search for 'common' dependencies =========
include(siconos_find_common_dep)

# ========= Python bindings =========
if(WITH_PYTHON_WRAPPER)
  add_subdirectory(wrap)
endif()

# ========= Tests setup =========
if(WITH_TESTING)
  include(CTest)
  include(SiconosCTest)
  # log file for tests setup
  file(WRITE ${CMAKE_BINARY_DIR}/tests.log "--- Siconos tests setup --- \n")
endif()

# ========= Documentation setup =========
# This includes doxygen_warnings,
# doxygen doc from source files, sphinx doc
# and docstrings from doxygen, depending on the
# enabled options.
add_subdirectory(docs)

# ========= Setup each required component =========
foreach(COMPONENT ${COMPONENTS})
  message("\n--------------------------------------------------")
  add_subdirectory(${COMPONENT})
endforeach()

finalize_doc()

include(FeatureSummary)
feature_summary(WHAT ALL)

# =========== Generate siconos scripts ===========
if(EXISTS ${CMAKE_SOURCE_DIR}/scripts/CMakeLists.txt.in)
  configure_file(scripts/CMakeLists.txt.in scripts/CMakeLists-temp.txt @ONLY)
  configure_file(${CMAKE_BINARY_DIR}/scripts/CMakeLists-temp.txt ${CMAKE_BINARY_DIR}/scripts/CMakeLists.txt @ONLY)
  install(FILES ${CMAKE_BINARY_DIR}/scripts/CMakeLists.txt DESTINATION share/${PROJECT_NAME})
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/scripts/siconos.py.in)
  message("-- Generate siconos script ...")
  configure_file(scripts/siconos.py.in scripts/siconos @ONLY)
  install(PROGRAMS ${CMAKE_BINARY_DIR}/scripts/siconos DESTINATION bin)
endif()

# ============= Save config for other cmake projects ============
include(CMakePackageConfigHelpers)

# Generate ${PROJECT_NAME}Config.cmake
configure_package_config_file(Config.cmake.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}Config.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/cmake)
install(FILES ${CMAKE_BINARY_DIR}/SiconosConfig.h DESTINATION include/${PROJECT_NAME})

# Generate configVersion.cmake file.
write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}
  COMPATIBILITY ExactVersion
  )

# install both of them
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}Config.cmake ${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
  DESTINATION share/${PROJECT_NAME}/cmake)

# ============= Summary =============
message(STATUS "\n============================================ Summary ============================================")
message(STATUS "${PROJECT_NAME} version ${SICONOS_VERSION} is now ready for compilation and installation.")
message(STATUS "To proceed run 'make' and 'make install' and optionaly 'make test'.")
message(STATUS "C++ Compiler : ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "C++ flags : ${CMAKE_CXX_FLAGS}")
message(STATUS "C Compiler : ${CMAKE_C_COMPILER} ${CMAKE_C_COMPILER_VERSION}")
message(STATUS "C flags : ${CMAKE_C_FLAGS}")
message(STATUS "Fortran Compiler : ${CMAKE_Fortran_COMPILER} ${CMAKE_Fortran_COMPILER_VERSION}")
message(STATUS "Fortran flags : ${CMAKE_Fortran_FLAGS}")
message(STATUS "Compilation mode is : ${CMAKE_BUILD_TYPE}")
message(STATUS "Code Sources are in : ${CMAKE_SOURCE_DIR}")
message(STATUS "Blas is ${WITH_BLAS}. ")
message("    Blas libraries : ${BLAS_LIBRARIES}.")
message("    Blas headers : ${BLAS_HEADER} in ${BLAS_INCLUDE_DIRS}.")
message(STATUS "Lapack is ${WITH_LAPACK}.")
message("    Lapack libraries : ${LAPACK_LIBRARIES}.")
message("    Lapack headers : ${LAPACK_HEADER} in ${LAPACK_INCLUDE_DIRS}.")
if (USE_SYSTEM_SUITESPARSE)
  message(STATUS "CXSparse headers : ${CXSparse_INCLUDE_DIR}")
  message(STATUS "CXSparse library : ${CXSparse_LIBRARY}")
else()
  message(STATUS "CSparse headers : externals/SuiteSparse/CSparse")
endif()
message(STATUS "Python interpreter is ${PYTHON_EXECUTABLE}")
message(STATUS "Python libraries are ${PYTHON_LIBRARIES}")
message(STATUS "All linking libraries are : ${SICONOS_LINK_LIBRARIES}.")
message(STATUS "All include directories are : ${SICONOS_INCLUDE_DIRECTORIES}.")
message(STATUS "The project will be installed in ${CMAKE_INSTALL_PREFIX}")
if(WITH_PYTHON_WRAPPER)
  message(STATUS "${SICONOS_PYTHON_PACKAGE} python package will be installed in ${SICONOS_PYTHON_INSTALL_DIR}")
endif()
message(STATUS "To get more information about dependencies, config or else, ")
message(STATUS "check CMakeCache.txt file or re-run cmake with -DPRINT_ENV=ON.")
message(STATUS "=================================================================================================\n")

# Log build info into ${CMAKE_BINARY_DIR}/Testing/Notes/Build
write_notes()

=== control/CMakeLists.txt ===
#================================================================
# cmake utilities to build control component
#================================================================

set(COMPONENT control)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# --- Search component dependencies ---

# --- Sources and headers ---
# source directories for numerics
set(${COMPONENT}_DIRS
  src/.
  src/utils
  src/Controller
  src/Observer
  src/Sensor
  src/Simulation
)

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS)

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR)

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE CXX)
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES numerics kernel)
if (CMAKE_SKIP_RPATH)
  # if no RPATH, then linking does not work for tests without specifying externals
  list(APPEND ${COMPONENT}_LINK_LIBRARIES externals)
endif()

include(WindowsControlSetup)

include(LibraryProjectSetup)
library_project_setup()

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== docs/CMakeLists.txt ===
# ============================================================
# Prepare  config to generate siconos documentation :
#
# - automatic doxygen documentation, from source code
# - sphinx documentation for manuals
# 
# ============================================================
include(FindPythonModule)
include(FindSphinxModule)

# Devel option : activate this to generate rst from doxygen xml outputs
# using doxyrest. 
option(USE_DOXYREST "Build rst files from doxygen outputs (tool = doxyrest). Default = OFF" OFF)
# Devel option : activate this to generate rst from doxygen xml outputs
# using exhale
option(USE_EXHALE "Build rst files from doxygen outputs (tool = exhale). Default = OFF" OFF)

# Devel option : generate pure doxygen doc (no sphinx), extracting all and with graphs.
option(USE_DEVEL_DOXYGEN "Build doxygen (html, latex ...) doc, extracting all. Devel purpose. Default = OFF" OFF)

set(DOC_ROOT_DIR ${CMAKE_BINARY_DIR}/docs/build CACHE INTERNAL "Root path to generated documentation.")
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build/html)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doctools.py ${CMAKE_BINARY_DIR}/share/doctools.py COPYONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/replace_py_escape.sh ${CMAKE_BINARY_DIR}/share/replace_py_escape.sh COPYONLY)

#  ====== doxygen documentation setup ======
# This setup is required if one at least of
# the following is needed:
# - doxygen warnings (see WITH_DOXYGEN_WARNINGS)
# - python docstrings from doxygen (xml) (see WITH_DOXY2SWIG)
# - doxygen documentation generated from source files (see WITH_DOCUMENTATION)
if(USE_DOXYGEN)

  # Search doxygen and set config
  find_package(Doxygen REQUIRED)
  # Output path for doxygen documentation
  if(NOT DOXYGEN_OUTPUT)
    set(DOXYGEN_OUTPUT ${DOC_ROOT_DIR}/doxygen CACHE INTERNAL "Path to doxygen outputs.")
  endif()

  file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT}/man)
  
  # --- Config files and their options. --
  # --> a lot for doxygen warnings (from doxy_warnings.config.in)
  # --> one for documentation (html and xml to sphinx) (from doxy.config.in)

  # == set configuration file for doxygen warnings ==
  #  - Results in binary_dir/doxygen_warnings
  #  - input config from config/doxy_warnings.config
  #  - only xml output.
  if(WITH_DOXYGEN_WARNINGS)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings/man)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doxygen_warnings/xml)
    set(DOXY_WARNINGS_CONFIG ${CMAKE_CURRENT_SOURCE_DIR}/config/doxy_warnings.config.in CACHE INTERNAL "config file for doxygen warnings output.")
    # All the configure process will be done for each component
    # thanks to 'include(doxygen_warnings)'. See LibraryProjectSetup.
  endif()

  # == set configuration file for doxygen doc from sources ==
  #  - Results in binary_dir/docs/
  #  - input config from config/doxy.config
  #  - only html output
  # 'inputs' are updated by each component, during call to update_doxy_config_file macro.
  # Doc will be built when 'make doxygen' is called.
  if(WITH_DOCUMENTATION)
    # config file name
    set(DOXY_CONFIG "${CMAKE_CURRENT_BINARY_DIR}/config/doxy.config" CACHE INTERNAL "Doxygen configuration file : used to produce html (doxygen only) and xml files for sphinx (breathe/exhale).")
    # The generation of the config and the creation of the target will be done later,
    # after the update of inputs by each component, with macro 'finalize_doc'
    
  endif()
endif()

  
#  ====== Create a Target to generate sphinx documentation ======
if(USE_SPHINX)
  if(USE_DOXYREST)
    find_package(doxyrest CONFIGS doxyrest_config.cmake REQUIRED)
    if(doxyrest_FOUND)
      set(HAS_DOXYREST "True" CACHE INTERNAL "True if doxyrest required and found.")
      message(STATUS "Doxyrest found : ${DOXYREST_EXE}")
    endif()
  else()
    set(HAS_DOXYREST "False" CACHE INTERNAL "True if doxyrest required and found.")
  endif()
  find_python_module(breathe REQUIRED)
  if(USE_EXHALE)
    find_python_module(exhale REQUIRED)
    set(HAS_EXHALE "True" CACHE INTERNAL "True if exhale required and found.")
  else()
    set(HAS_EXHALE "False" CACHE INTERNAL "True if exhale required and found.")
  endif()
  find_python_module(sphinx REQUIRED)
  find_sphinx_module(sphinxcontrib bibtex REQUIRED)
  #find_python_module(numpydoc REQUIRED)
  #find_sphinx_module(sphinxcontrib doxylink REQUIRED)
  find_sphinx_module(sphinxcontrib youtube)
  if(NOT ${youtube_FOUND})
    # This python package can not be found using standard ways such as conda or pip,
    # so we force download and install.
    message("Can not found sphinxcontrib-youtube. It will be downloaded and installed ...")
    execute_process(
      COMMAND ${PYTHON_EXECUTABLE} -m pip install git+https://github.com/sphinx-contrib/youtube.git)
    find_sphinx_module(sphinxcontrib youtube REQUIRED)
  endif()
  # Sphinx theme for documentation
  #find_python_module(sphinx-bootstrap-theme REQUIRED)
  find_python_module(sphinx_bootstrap_theme REQUIRED)
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/index.rst.in"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/index.rst" @ONLY)

  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/siconos.bib"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/siconos.bib" COPYONLY)

  configure_file(${CMAKE_SOURCE_DIR}/externals/swig/parse_doxygen.py ${CMAKE_BINARY_DIR}/share/parse_doxygen.py COPYONLY)
  
  # List and copy all rst files from source dir to binary dir
  file(GLOB_RECURSE files_rst RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/sphinx
    ${CMAKE_CURRENT_SOURCE_DIR}/sphinx/*.rst)
  foreach(filepath ${files_rst})
    #get_filename_component(filename ${filepath} NAME)
    
    configure_file (
      "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/${filepath}"
      "${CMAKE_CURRENT_BINARY_DIR}/sphinx/${filepath}" COPYONLY)
  endforeach()
  
  # html menu
  #configure_file (
  #  "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/_templates/menu.html"
  #  "${CMAKE_CURRENT_BINARY_DIR}/sphinx/_templates/menu.html" COPYONLY)

  # css
  configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/sphinx/_static/biblio.css"
    "${CMAKE_CURRENT_BINARY_DIR}/sphinx/_static/biblio.css" COPYONLY)

  
  # --- Build a target for sphinx ---
  # --> use make html or make latex ... to build documentation.
  set(SPHINX_EXECUTABLE sphinx-build)
  set(SPHINX_LOG_FILE ${CMAKE_BINARY_DIR}/docs/sphinx_warnings.log)    
  if(HAS_EXHALE)
    set(SPHINX_PARAMETERS
      -b html # html output
      -d build/doctrees # path to doctree files
      ${CMAKE_CURRENT_BINARY_DIR}/sphinx  # path to rst source
      -t WithExhale
      )
    
  else()
    set(SPHINX_PARAMETERS
      -w ${SPHINX_LOG_FILE}
      -b html # html output
      -d build/doctrees # path to doctree files
      ${CMAKE_CURRENT_BINARY_DIR}/sphinx  # path to rst source
      -t WithoutExhale
      )
  endif()

  # -- Target to copy figures required by sphinx from source to binary dir --
  #  make copy-sphinx-figures
  add_custom_target(copy-sphinx-figures
    COMMAND cmake -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/sphinx/figures ${CMAKE_CURRENT_BINARY_DIR}/sphinx/figures
    )
  
  add_custom_target(create_rst
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_BINARY_DIR}/share ${PYTHON_EXECUTABLE} -c
    "import doctools; doctools.build_api_main('${CMAKE_CURRENT_BINARY_DIR}/sphinx')"
    VERBATIM
    COMMENT "Create main rst files for C/C++ and python API.")
  
  # -- To build html doc : make html --
  add_custom_target(html
    COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_PARAMETERS} 2> errors.txt ${CMAKE_CURRENT_BINARY_DIR}/build/html
    VERBATIM
    DEPENDS copy-sphinx-figures create_rst
    )

  add_custom_command(TARGET html POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_BINARY_DIR}/share ${PYTHON_EXECUTABLE} -c
      "import doctools; doctools.filter_sphinx_warnings('${SPHINX_LOG_FILE}')"
      VERBATIM
      COMMENT "Filtering sphinx logfile into ${SPHINX_LOG_FILE}.")

  add_custom_command(TARGET html POST_BUILD
      COMMENT "Done. Sphinx doc has been generated in ${DOC_ROOT_DIR}/html")

  # Option to be tested later : generate docs for a list of tags, branches ...
  add_custom_target(html-multiversion
    COMMAND sphinx-versioning -g ${CMAKE_SOURCE_DIR} build docs/sphinx 
    ${CMAKE_CURRENT_BINARY_DIR}/build/html
    )
  
  # -- To use doxyrest to generate rst files from doxygen (xml) outputs : make doxyrest --
  # Note FP : test purpose only, exhale/breathe seems to be better than doxyrest.
  if(HAS_DOXYREST)
    add_custom_target(doxyrest
      COMMAND ${DOXYREST_EXE} ${DOXYGEN_OUTPUT}/xml/index.xml -o ${CMAKE_CURRENT_BINARY_DIR}/sphinx/from_doxygen/index.rst -F ${DOXYREST_FRAME_DIR} -f c_index.rst.in
      )
    add_dependencies(html doxyrest)
  endif()

  # -- To build latex doc : make latex -- 
  set(SPHINX_LATEX_PARAMETERS
    -b latex # latex output
    -d build/doctrees # path to doctree files
    ${CMAKE_CURRENT_BINARY_DIR}/sphinx  # path to rst source
    )
  
  add_custom_target(latex
    COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_LATEX_PARAMETERS}
    ${CMAKE_CURRENT_BINARY_DIR}/build/latex
    )

  add_custom_target(doc DEPENDS html)
  
  # # -- Target to build python api documention with apidoc --
  # # make apidoc
  # if(WITH_PYTHON_WRAPPER)
  #   set(SPHINX_APIDOC sphinx-apidoc)
  #   set(GENERATED_DOC ${CMAKE_CURRENT_BINARY_DIR}/sphinx/reference)
  #   set(APIDOC_PARAMETERS -e -M -o ${GENERATED_DOC})
  #   # -e : Put documentation for each module on its own page
  #   # -P : Include “_private” modules. (should we??)
  #   # -M : Put module documentation before submodule documentation.
  #   # -a : append documented module path to sys.path
  #   list(GET COMPONENTS -1 _last_comp)
  #   # apidoc must be run AFTER swig process --> depends on components
  #   add_custom_target(apidoc
  #     COMMAND ${CMAKE_COMMAND} -E env "SPHINX_APIDOC_OPTIONS='members','undoc-members'" ${SPHINX_APIDOC} ${APIDOC_PARAMETERS}
  #     ${CMAKE_BINARY_DIR}/wrap/${SICONOS_PYTHON_PACKAGE}
  #     DEPENDS ${_last_comp}
  #     )

  #   # Sphinx html gen. depends on apidoc outputs.
  #   if(WITH_DOXY2SWIG)
  #     #add_dependencies(html apidoc)
  #   endif()
  # endif()

endif()

=== docs/requirements.txt ===
scipy
lxml
pytest
matplotlib
h5py
sphinx<1.8
sphinx-rtd-theme
sphinxcontrib-bibtex
sphinxcontrib-websupport
sphinx-bootstrap-theme
sphinxcontrib-napoleon
numpydoc
breathe

=== externals/CMakeLists.txt ===
#================================================================
# cmake utilities to build external component
#================================================================

set(COMPONENT externals)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# Define a Fortran interface file (FCMangle.hpp)
#FortranCInterface_VERIFY(QUIET)
if(NOT FortranCInterface_VERIFIED_C)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DefaultMangle.h.in ${CMAKE_CURRENT_BINARY_DIR}/FCMangle.h)
else()
  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/FCMangle.h
    MACRO_NAMESPACE "myF2C" 
    SYMBOL_NAMESPACE "myF2C"
    )
endif()

# --- Sources and headers ---
# source directories for externals
set(${COMPONENT}_DIRS
  .
  blas_lapack
  hairer
  netlib/dftemplates
  netlib/odepack
  optim_misc
  optim_misc/ql0001
  SOL/lumod-c
  sort
  tools
)

if (NOT USE_SYSTEM_SUITESPARSE)
  LIST(APPEND ${COMPONENT}_DIRS SuiteSparse/CXSparse)
endif()

if(WITH_CXX)
  list(APPEND ${COMPONENT}_DIRS numeric_bindings boost_contribs)
  if(NOT WITH_SYSTEM_BOOST_SERIALIZATION)
    list(APPEND ${COMPONENT}_DIRS boost_serialization)
  endif()
endif()

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS)

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR PATH_SDK/include SOL/lumod-c)
if(NOT INSTALL_EXTERNAL_HEADERS)
  list(APPEND ${COMPONENT}_HDRS_EXCLUDE_DIR
    blas_lapack
    hairer
    netlib/dftemplates
    netlib/odepack
    optim_misc
    optim_misc/ql0001
    sort
    boost_contribs
    tools)
endif()

# List of specific headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE tools/SiconosCompat.h)

if (USE_SYSTEM_SUITESPARSE)
  list(APPEND ${COMPONENT}_HDRS_EXCLUDE_DIR
    SuiteSparse/CXSparse)
endif()

# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
# No docs for externals.
set(${COMPONENT}_EXCLUDE_DOXY
  # .
  ${${COMPONENT}_DIRS}
  )

SET(${COMPONENT}_EXCLUDE_SRCS "SOL/lumod-c/sparselib.c" "SOL/lumod-c/lumod_sparse.c")

set_source_files_properties(SOL/lumod-c/lumod_dense.c PROPERTIES COMPILE_FLAGS -Wno-unused-variable)
set_source_files_properties(SOL/lumod-c/commonlib.c PROPERTIES COMPILE_FLAGS -Wno-unused-variable)
if (NOT USE_SYSTEM_SUITESPARSE)
  set_source_files_properties(SuiteSparse/CSparse/csparse.c PROPERTIES COMPILE_FLAGS -Wno-unused)
endif()



if(NOT HAS_ATLAS_LAPACK)
  set(${COMPONENT}_EXCLUDE_SRCS ${${COMPONENT}_EXCLUDE_SRCS} "blas_lapack/clapack_dtrtrs.c")
endif()

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE C)
# but CXX may be needed with MlcpSimplex
if(MLCPSIMPLEX_FOUND) 
  set(${COMPONENT}_LINKER_LANGUAGE CXX)
endif()
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${CMAKE_DL_LIBS}) # needed by GAMS
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})

# Windows stuff
include(WindowsExternalsSetup)

if(BUILD_AS_CPP)
  file(GLOB_RECURSE C_FILES ${CMAKE_CURRENT_SOURCE_DIR} *.c)
  set_source_files_properties(${C_FILES} PROPERTIES LANGUAGE CXX
    COMPILE_FLAGS -fpermissive)
  set(${COMPONENT}_LINKER_LANGUAGE CXX)
endif()

check_c_compiler_flag("-Wno-error=float-conversion" W_no_error_float_conversion_flag)
check_c_compiler_flag("-Wno-error=conversion" W_no_error_conversion_flag)
check_c_compiler_flag("-Wno-conversion" W_no_conversion_flag)
check_c_compiler_flag("-fpermissive" fpermissive_flag)


if(NOT USE_SYSTEM_SUITESPARSE)
  file(GLOB_RECURSE CXSPARSE_FILES ${CMAKE_CURRENT_SOURCE_DIR}  cxsparse_*.c)
  if(BUILD_AS_CPP)
    set(_flags)
    if(W_no_error_float_conversion_flag)
      set(_flags "-Wno-error=float-conversion")
    endif()
    if(W_no_error_conversion_flag)
      set(_flags "${_flags} -Wno-error=conversion")
    endif()
    if(W_no_conversion_flag)
      set(_flags "${_flags} -Wno-conversion")
    endif()
    if(fpermissive_flag)
      set(_flags "${_flags} -fpermissive")
    endif()
    if(_flags)
      set_source_files_properties(${CXSPARSE_FILES} PROPERTIES COMPILE_FLAGS ${_flags})
    endif()
  else()
    set(_flags)
    if(W_no_error_conversion_flag)
      set(_flags "-Wno-error=conversion")
    endif()
    if(W_no_error_float_conversion_flag)
      set(_flags "${_flags} -Wno-error=float-conversion")
    endif()
    if(W_no_conversion_flag)
      set(_flags "${_flags} -Wno-conversion")
    endif()
    if(_flags)
      set_source_files_properties(${CXSPARSE_FILES} PROPERTIES COMPILE_FLAGS ${_flags})
    endif()
  endif()
endif()

include(LibraryProjectSetup)
library_project_setup()



# --- specific install ----
#install(FILES ${CMAKE_CURRENT_BINARY_DIR}/FCMangle.h DESTINATION include/${PROJECT_NAME})

if(HAVE_SICONOS_MECHANICS AND WITH_RENDERER)
  # This files is not installed as a program, even though it is one.
  # Remove the comment if you know how it should be installed --xhub
  #  configure_file(io/SimpleGui.py ${SICONOS_SWIG_ROOT_DIR}/io/SimpleGui.py @ONLY) 


  file(GLOB rendererFiles RELATIVE ${CMAKE_SOURCE_DIR}/externals/renderer  ${CMAKE_SOURCE_DIR}/externals/renderer/img/*.*)
  foreach(rendererFile ${rendererFiles})
    set(srcRendererPath ${CMAKE_SOURCE_DIR}/externals/renderer/${rendererFile})
    if(NOT IS_DIRECTORY ${srcRendererPath})     
      install(FILES  ${srcRendererPath} DESTINATION share/siconos/renderer/img)
    endif(NOT IS_DIRECTORY ${srcRendererPath})
  endforeach(rendererFile)

  file(GLOB rendererFiles RELATIVE ${CMAKE_SOURCE_DIR}/externals/renderer/  ${CMAKE_SOURCE_DIR}/externals/renderer/threeJS_libraries/*.*)
  foreach(rendererFile ${rendererFiles})
    set(srcRendererPath ${CMAKE_SOURCE_DIR}/externals/renderer/${rendererFile})
    if(NOT IS_DIRECTORY ${srcRendererPath})     
      install(FILES  ${srcRendererPath} DESTINATION share/siconos/renderer/threeJS_libraries  )
    endif(NOT IS_DIRECTORY ${srcRendererPath})
  endforeach(rendererFile)

  if(INSTALL_PYTHON_SYMLINKS)
    message("Setting up symlink install targets for externals Python executables")
    install(CODE "execute_process(COMMAND sh -c \"test -e '${CMAKE_INSTALL_PREFIX}/bin/siconos_renderer' || ln -vs '${CMAKE_CURRENT_SOURCE_DIR}/renderer/renderer.py' '${CMAKE_INSTALL_PREFIX}/bin/siconos_renderer'\")")
  else()
    install(PROGRAMS renderer/renderer.py
      DESTINATION bin RENAME siconos_renderer)
  endif()

endif()

if(WITH_SERIALIZATION AND INSTALL_EXTERNAL_HEADERS AND NOT WITH_SYSTEM_BOOST_SERIALIZATION)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_load_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_save_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_map.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_set.hpp
    DESTINATION include/${PROJECT_NAME}/boost/serialization)
endif()




# --- tests ---
include(${COMPONENT}_tests.cmake)


# We don't want warnings from externals libraries.
target_compile_options(externals PRIVATE "-w")

=== io/CMakeLists.txt ===
#================================================================
# cmake utilities to build IO component
#================================================================

set(COMPONENT io)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# --- Search component dependencies ---
if(WITH_SERIALIZATION)
  find_package(Boost 1.47 COMPONENTS serialization REQUIRED)
  find_package(Boost 1.47 COMPONENTS filesystem REQUIRED)
  # cmake 2.8.12.2 (ubuntu 14.04) need this
  set(${COMPONENT}_LINK_LIBRARIES  "${${COMPONENT}_LINK_LIBRARIES};${Boost_LIBRARIES}")
endif()
# Right now boost::serialization does some nasty things... so we have to
# disable some undefined behavior checks ...
IF(USE_SANITIZER MATCHES "asan")
  ADD_CXX_OPTIONS("-fno-sanitize=vptr")
  ADD_CXX_OPTIONS("-fno-sanitize=alignment")
  ADD_CXX_OPTIONS("-fno-sanitize=null")
ENDIF(USE_SANITIZER MATCHES "asan")
# Note FP : we should move this to CXXCompilerSetup?
# Answer xhub : no this is local, because boost::serialization is hackish

# --- Sources and headers ---
# source directories for numerics
set(${COMPONENT}_DIRS
  src/.)

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS
  )
if(HAVE_SICONOS_MECHANICS)
  list(APPEND ${COMPONENT}_DIRS src/mechanics)
endif()

if(WITH_VTK)
  list(APPEND ${COMPONENT}_DIRS VTK)
  set(${COMPONENT}_LINK_LIBRARIES "${${COMPONENT}_LINK_LIBRARIES};vtkIO;vtkCommon;vtkGraphics;vtkRendering")
endif()

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR)

# --- Serialization setup ---
set(GENERATED_HEADER ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullGenerated.hpp)
set(GENERATED_HEADER_KERNEL ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullKernelGenerated.hpp)


if(WITH_SERIALIZATION)
  if(WITH_GENERATION)
    FILE(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullGenerated.hpp)
    FILE(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullKernelGenerated.hpp)

    set(io_targets ${COMPONENTS})

    # REMOVE_item not on cmake 2.8 ...
    list(REMOVE_ITEM io_targets numerics io externals)
    print_var(io_targets)

    string(REPLACE ";" "," io_targets_list "${io_targets}")
    SET(GENERATED_TARGETS --targets=${io_targets_list})

    if(HAVE_SICONOS_KERNEL)
      set(GENERATED_DEPENDENCIES ../kernel/src/SiconosKernel.hpp)
    endif()
    if(HAVE_SICONOS_MECHANICS)
      set(GENERATED_DEPENDENCIES ${GENERATED_DEPENDENCIES}
        ../mechanics/src/collision/native/SpaceFilter.hpp)
    endif()
    if(HAVE_SICONOS_CONTROL)
      set(GENERATED_DEPENDENCIES ${GENERATED_DEPENDENCIES} ../control/src/SiconosControl.hpp)
    endif()

    # append local headers directories to GENERATED_INCLUDES)
    foreach(_DIR ${${PROJECT_NAME}_LOCAL_INCLUDE_DIRECTORIES})
      list(APPEND GENERATED_INCLUDES -I${_DIR})
    endforeach()

    if(MPI_FOUND)
      FOREACH(_DIR ${MPI_CXX_INCLUDE_PATH})
        SET(GENERATED_INCLUDES ${GENERATED_INCLUDES} -I${_DIR})
      ENDFOREACH()
    ENDIF()

    SET(GENERATED_COMMAND COMMAND ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      ${GENERATED_TARGETS} ${GENERATED_INCLUDES} --output=${GENERATED_HEADER}
      --source="${CMAKE_CURRENT_SOURCE_DIR}/../" --build="${CMAKE_BINARY_DIR}")

    ADD_CUSTOM_COMMAND(
      OUTPUT ${GENERATED_HEADER}
      DEPENDS doxygen ${GENERATED_DEPENDENCIES}
      ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      ${CMAKE_SOURCE_DIR}/io/tools/builder_common.py
      ${GENERATED_COMMAND})

    SET(GENERATED_COMMAND_KERNEL COMMAND ${CMAKE_SOURCE_DIR}/io/tools/build_from_doxygen.py
      --targets=kernel ${GENERATED_INCLUDES}
      --output=${GENERATED_HEADER_KERNEL}
      --source="${CMAKE_CURRENT_SOURCE_DIR}/../" --build="${CMAKE_BINARY_DIR}")

    ADD_CUSTOM_COMMAND(
      OUTPUT ${GENERATED_HEADER_KERNEL}
      DEPENDS doxygen ${GENERATED_DEPENDENCIES}
      ${GENERATED_COMMAND_KERNEL})
  endif()
endif()

# wrap - Set extra dependencies
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS)
  # List of modules to be built in the python bindings
  set(${COMPONENT}_PYTHON_MODULES "${COMPONENT}")
endif()#


# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE CXX)
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES kernel numerics)
if (CMAKE_SKIP_RPATH)
  # if no RPATH, then linking does not work for tests without specifying externals
  list(APPEND ${COMPONENT}_LINK_LIBRARIES externals)
endif()

if(HAVE_SICONOS_CONTROL)
  list(APPEND ${COMPONENT}_LINK_LIBRARIES control)
endif()
if(HAVE_SICONOS_MECHANICS)
  list(APPEND ${COMPONENT}_LINK_LIBRARIES mechanics)
endif()

# remove debug & optimized inside LINK_LIBRARIES...
list(REMOVE_ITEM ${COMPONENT}_LINK_LIBRARIES "debug" "optimized")

# add dependencies for header generation
add_custom_target(SerializersGeneration ALL
  DEPENDS ${GENERATED_HEADER} ${GENERATED_HEADER_KERNEL})

include(LibraryProjectSetup)

library_project_setup()

add_dependencies(${COMPONENT} SerializersGeneration)

# --- specific install ----
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullGenerated.hpp
  DESTINATION include/${PROJECT_NAME})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFullNumerics.hpp
    DESTINATION include/${PROJECT_NAME})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/Register.hpp
    DESTINATION include/${PROJECT_NAME})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosRestart.hpp
    DESTINATION include/${PROJECT_NAME})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/SiconosFull.hpp
    DESTINATION include/${PROJECT_NAME})
if(HAVE_SICONOS_MECHANICS)
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/src/mechanics/MechanicsIO.hpp
    DESTINATION include/${PROJECT_NAME})
endif()

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== kernel/CMakeLists.txt ===
#================================================================
# cmake utilities to build kernel component
#================================================================

set(COMPONENT kernel)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# --- Search component dependencies ---

# --- Sources and headers ---
# source directories for numerics
set(${COMPONENT}_DIRS
  src/.
  src/utils
  src/utils/SiconosAlgebra
  src/utils/SiconosException
  src/utils/SiconosMemory
  src/utils/SiconosSharedLibrary
  src/utils/SiconosTools
  src/plugin
  src/modelingTools
  src/simulationTools
)

set(${COMPONENT}_HDRS_EXCLUDE
  src/utils/SiconosTools/CxxStd.hpp
  )

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS
  )

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE CXX)
# CMAKE_DL_LIBS for dlopen or equivalent (used for plugins)
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${CMAKE_DL_LIBS})
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES externals numerics)

include(WindowsKernelSetup)
# Some directories to exclude from xml to swig process
set(${COMPONENT}_EXCLUDE_DOXY
  src/utils/SiconosTools # if included, it breaks swig process for mechanics
  )

include(LibraryProjectSetup)
library_project_setup()

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== mechanics/CMakeLists.txt ===
#================================================================
# cmake utilities to build mechanics component
#================================================================

# This component has two optional sub-parts:
# - collision/bullet which requires bullet physics software  (and thus -DWITH_BULLET=ON cmake option)
# - occ which requires open-cascade community edition (and thus -DWITH_OCE=ON cmake option)
# Those parts are automatically built and installed if bullet and/or oce are available and properly detected by cmake.


set(COMPONENT mechanics)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})


# --- Sources and headers for 'native' mechanics part ---
set(${COMPONENT}_DIRS
  src/.
  src/collision
  src/collision/native
  src/collision/native/bodies
  src/joints
  )

# --- Optional parts ---

# -- Bullet --
# Must :
# - check if bullet is available on the system
# Will:
# - add collision/bullet to the build process
# - set SICONOS_HAS_BULLET var (distributed in siconosConfig.cmake)
if(WITH_BULLET)
  
  find_package(Bullet REQUIRED)
  # --> set BULLET_INCLUDE_DIRS, BULLET_FOUND, BULLET_LIBRARIES.
  # --> Accept : BULLET_ROOT (as install path or Windows build path)
  if(BULLET_FOUND)
    set(SICONOS_HAS_BULLET TRUE)
    # If a custom bullet was set, provide it for user programs.
    message(STATUS "Bullet found.")
    message("    Bullet libraries : ${BULLET_LIBRARIES}.")
    message("    Bullet headers path : ${BULLET_INCLUDE_DIRS}.")
    # Append mechanics bullet component sources to sources list
    list(APPEND ${COMPONENT}_DIRS src/collision/bullet)

    set(${COMPONENT}_LINK_LIBRARIES ${${COMPONENT}_LINK_LIBRARIES} ${BULLET_LIBRARIES})
    # Add bullet headers to search path
    # 'private' add limited to current target would be better.
    # But those headers are missing during swig process. Todo : find a proper
    # way to deal with this.
    # target_include_directories(${COMPONENT} PRIVATE ${BULLET_INCLUDE_DIRS})
    include_directories(${BULLET_INCLUDE_DIRS})
    # Add bullet libs to components links
    set(${COMPONENT}_LINK_LIBRARIES ${${COMPONENT}_LINK_LIBRARIES} ${BULLET_LIBRARIES})
  endif()
endif()



# -- OCE --
# Must :
# - check if oce is available on the system
# Will:
# - add occ to the build process
# - set SICONOS_HAS_OCE var (distributed in siconosConfig.cmake)
if(WITH_OCE)
  include(oce_setup)
  # Source dir for 'oce' component
  list(APPEND ${COMPONENT}_DIRS src/occ)
  # Add oce headers to search path
  # 'private' add limited to current target would be better.
  # But those headers are missing during swig process. Todo : find a proper
  # way to deal with this.
  # target_include_directories(${COMPONENT} PRIVATE ${OCE_INCLUDE_DIRS})
  include_directories(${OCE_INCLUDE_DIRS})
  # Add oce libs to components links
  set(${COMPONENT}_LINK_LIBRARIES ${${COMPONENT}_LINK_LIBRARIES} ${OCE_LIBRARIES})

endif()

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS
  )

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR)

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE CXX)
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES numerics externals kernel)




if(WITH_OCE OR CMAKE_SKIP_RPATH)
  # if no RPATH, then linking does not work for tests without specifying externals
  # for n2qn1
  set(${COMPONENT}_LINK_LIBRARIES ${${COMPONENT}_LINK_LIBRARIES} externals)
endif()

include(LibraryProjectSetup)

library_project_setup()


if(SICONOS_HAS_BULLET)
  # Add bullet headers to search path
  #target_include_directories(${COMPONENT} PRIVATE ${BULLET_INCLUDE_DIRS})
  # Add bullet libs to components links
  # target_link_libraries(${COMPONENT} PRIVATE ${BULLET_LIBRARIES})

  # Update compile flags for component
  if(BULLET_USE_DOUBLE_PRECISION)
    # Do we need this as public or private? Check if mechanics io needs this option?
    target_compile_options(${COMPONENT} PUBLIC "-DBT_USE_DOUBLE_PRECISION")
  endif()
endif()


# --- tests ---
include(${COMPONENT}_tests.cmake)

=== mechanisms/CMakeLists.txt ===
#================================================================
# cmake utilities to build mechanisms component
#================================================================

set(COMPONENT mechanisms)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# --- Search component dependencies ---
if(NOT WITH_OCE)
  message(FATAL_ERROR "Please run cmake again with option WITH_OCE=ON (required for mechanisms) or do not setup Siconos with mechanisms component.")
endif()

include(oce_setup)
# Add oce headers to search path
# 'private' add limited to current target would be better.
# But those headers are missing during swig process. Todo : find a proper
# way to deal with this.
# target_include_directories(${COMPONENT} PRIVATE ${OCE_INCLUDE_DIRS})
include_directories(${OCE_INCLUDE_DIRS})
# Add oce libs to components links
set(${COMPONENT}_LINK_LIBRARIES ${${COMPONENT}_LINK_LIBRARIES} ${OCE_LIBRARIES})

# --- Sources and headers ---
# source directories for numerics
set(${COMPONENT}_DIRS
  src/
  src/CADMBTB
  src/MBTB
  src/TIMERMBTB)

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS
  )

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR)

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE CXX)
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES numerics externals kernel mechanics)


include(LibraryProjectSetup)
library_project_setup()

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== numerics/CMakeLists.txt ===
#================================================================
# cmake utilities to build numerics component
#================================================================

set(COMPONENT numerics)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")
# Name used for the target to be built
set(COMPONENT_LIBRARY_NAME ${PROJECT_NAME}_${COMPONENT})

# --- Numerics optional dependencies ---
include(gams_setup)


# --- Sources and headers ---
# source directories for numerics
set(${COMPONENT}_DIRS
  src/.
  src/tools
  src/tools/InterfaceToPathFerris
  src/tools/internal
  src/AVI
  src/LCP
  src/MLCP
  src/SOCP
  src/QP
  src/Relay
  src/FrictionContact
  src/FrictionContact/Generated
  src/NCP
  src/MCP
  src/GenericMechanical
  src/VI
)

# Static verifications (ACSL)
if(WITH_FRAMA_C)
  include(FramaC)
  file(GLOB frama_c_files src/FrictionContact/Generated/*.c)
  foreach(f ${frama_c_files})
    add_frama_c_test(${f} ENTRY main)
  endforeach()
  add_frama_c_test(${CMAKE_CURRENT_SOURCE_DIR}/src/tools/test/test_static_op3x3.c ENTRY main INCLUDES ${CMAKE_SOURCE_DIR}/externals/tools)
endif()

# Unstable sources. Will be included only
# if WITH_${COMPONENT}_UNSTABLE is true.
set(${COMPONENT}_Unstable_SRCS)

# List of directories of headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE_DIR)

# List of specific headers not to be installed
set(${COMPONENT}_HDRS_EXCLUDE
  src/FrictionContact/Generated/funcodegen.h
  )

# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
set(${COMPONENT}_EXCLUDE_DOXY
  src/Unstable_or_deprecated)

# Windows stuff
include(WindowsNumericsSetup)

# ---- Final setup for the library ----
# --- set linked libraries and linker language ---
set(${COMPONENT}_LINKER_LANGUAGE C)
# but CXX may be needed with MlcpSimplex
if(MLCPSIMPLEX_FOUND) 
  set(${COMPONENT}_LINKER_LANGUAGE CXX)
endif()
# CMAKE_DL_LIBS needed for dlopen or equivalent
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${CMAKE_DL_LIBS})
list(APPEND ${COMPONENT}_LINK_LIBRARIES ${SICONOS_LINK_LIBRARIES})
list(APPEND ${COMPONENT}_LINK_LIBRARIES externals)

set(COMPONENT_TEST_LIB "numerics-test")
include(LibraryProjectSetup)
library_project_setup()

if(BUILD_AS_CPP)
  file(GLOB_RECURSE C_FILES ${CMAKE_CURRENT_SOURCE_DIR} *.c)
  set_source_files_properties(${C_FILES} PROPERTIES LANGUAGE CXX)
  set(${COMPONENT}_LINKER_LANGUAGE CXX)
endif()

# --- tests ---
include(${COMPONENT}_tests.cmake)

=== wrap/CMakeLists.txt ===
# ============================================================
# Prepare swig config to generate python bindings for siconos
# ============================================================
if(WITH_PYTHON_WRAPPER)
  # Name of the generated Python package
  set(SICONOS_PYTHON_PACKAGE ${PROJECT_NAME} CACHE INTERNAL "Name of the siconos python module.")
  
  # --------------- Python install setup ---------------
  # Directory of all config files for python bindings.
  # Set path for siconos-python installation
  include(PythonInstallSetup)
  set_python_install_path()
  
  #  ----------- swig -----------

  # -- Swig flags --
  if(SYSTEM_ARCHITECTURE)
    list(APPEND CMAKE_SWIG_FLAGS "-D__${SYSTEM_ARCHITECTURE}__")
  endif()

  if(PYTHON_VERSION_MAJOR VERSION_GREATER 2)
    list(APPEND CMAKE_SWIG_FLAGS "-py3")
  endif()

  list(REMOVE_DUPLICATES CMAKE_SWIG_FLAGS)
  set(CMAKE_SWIG_FLAGS "${CMAKE_SWIG_FLAGS}" CACHE INTERNAL "Swig flags")

  # -dirvtable      - Generate a pseudo virtual table for directors for faster dispatch
  # - without "dirprot", swig wrap public methods and only the 
  # protected methods needed to the interface to compile.
  # - with "dirprot" swig will attemp to wrap all the public and protected methods at once.
  set(SWIG_DEFS "-dirprot;-dirvtable;-Wextra")
  
  if(WITH_FCLIB)
    set(SWIG_DEFS "${SWIG_DEFS};-DWITH_FCLIB")
  endif()
  
  if(HAVE_SICONOS_IO)
    set(SWIG_DEFS "${SWIG_DEFS};-DWITH_IO")
    if(WITH_SERIALIZATION)
      set(SWIG_DEFS "${SWIG_DEFS};-DWITH_SERIALIZATION")
    endif()
  endif()
  # -- Swig files --
  # i.e. .i files, common to all modules and submodules.
  set(SICONOS_SWIG_SRC_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/swig
    CACHE INTERNAL "Path to swig files common to all packages.")

  # -- Output dir --
  set(SICONOS_SWIG_ROOT_DIR ${CMAKE_CURRENT_BINARY_DIR}/${SICONOS_PYTHON_PACKAGE}
    CACHE INTERNAL "Root path for swig outputs.")

  # -- include dir --
  set(SICONOS_SWIG_INCLUDE_DIRS ${SICONOS_SWIG_SRC_DIRS} ${SICONOS_SWIG_ROOT_DIR} ${PYTHON_INCLUDE_DIRS}
    CACHE INTERNAL "Directories required for swig includes.")

  foreach(_dir ${SICONOS_SWIG_INCLUDE_DIRS})
    set(SWIG_DEFS "-I${_dir};${SWIG_DEFS}")
  endforeach()

  set(SWIG_DEFS "${SWIG_DEFS}" CACHE INTERNAL "Swig extra definitions.")

  include_directories(${SICONOS_SWIG_INCLUDE_DIRS})

  # ------------- Tests -------------
  if(WITH_TESTING)
    IF(CROSSCOMPILING_LINUX_TO_WINDOWS)
      SET(EMULATOR "wine")
      SET(DRIVE_LETTER "Z:")
    ELSE()
      SET(EMULATOR)
      SET(DRIVE_LETTER)
    ENDIF()

    # if a (DY)LD_LIBRARY_PATH is needed, export it
    set(EXPORT_LDLIBPATH)
    include(tools4tests)
    set_ldlibpath()
    if(LDLIBPATH)
      # put quotes around the paths for export
      string(REPLACE "=" ";" ENV_LDLIBPATH "${LDLIBPATH}")
      list(GET ENV_LDLIBPATH 0 ENV_LDLIBPATH_NAME)
      list(GET ENV_LDLIBPATH 1 ENV_LDLIBPATH_PATH)
      set(EXPORT_LDLIBPATH "export ${ENV_LDLIBPATH_NAME}=\"${ENV_LDLIBPATH_PATH}\"")
    endif()

    find_python_module(pytest REQUIRED)
    # -- Runner for tests --
    set(TESTS_RUNNER ${CMAKE_CURRENT_BINARY_DIR}/runtests.py CACHE INTERNAL "driver for python tests")
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/runtests.py.in)
      message(STATUS "Generate runtests.py file ...")
      configure_file(runtests.py.in ${TESTS_RUNNER})
    endif()
    if(WITH_AGGRESSIVE_PYTHON_TESTS)
      set(pytest_opt "-s -v -pep8" CACHE INTERNAL "extra options for py.test")
    else()
      set(pytest_opt "-v" CACHE INTERNAL "extra options for py.test")
    endif()
    file(MAKE_DIRECTORY ${SICONOS_SWIG_ROOT_DIR}/tests)
    configure_file(tests_setup.py.in ${SICONOS_SWIG_ROOT_DIR}/tests_setup.py)
    configure_file(set_tests_env.sh.in set_tests_env.sh)
    configure_file(utils/__init__.py ${SICONOS_SWIG_ROOT_DIR}/tests/__init__.py)
    add_custom_target(set_envtest numerics
      COMMAND sh ${CMAKE_CURRENT_BINARY_DIR}/set_tests_env.sh
      COMMENT "set environment variables for python tests ...")
    # todo if we need to add some 'global' tests for siconos (not component dependent)
    # create a wrap/swig/tests dir and ...
    #build_python_tests()
  endif()

  # ====== Generates python files required for build/install process ======
  
  set(SICONOS_PYTHON_MODULES)
  foreach(comp ${COMPONENTS})
    if(WITH_${comp}_PYTHON_WRAPPER)
      set(SICONOS_PYTHON_MODULES "'${comp}', ${SICONOS_PYTHON_MODULES}")
    endif()
  endforeach()
  # setup.py --> CMAKE_BINARY_DIR
  if(EXISTS  ${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in)
    message(STATUS "Generate setup.py file ...")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in setup.py)
  endif()

  # The file __init__.py will be generated from __init__.py.in.
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in)
    message(STATUS "Generate __init__.py file ...")
    if(EXISTS ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
      file(REMOVE ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
    endif()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/__init__.py.in ${SICONOS_SWIG_ROOT_DIR}/__init__.py)
  endif()

  # Some python files, that do not depend on siconos
  # but may be useful ...
  file(GLOB pyfiles ${CMAKE_CURRENT_SOURCE_DIR}/utils/[^_]*.py)
  foreach(_file ${pyfiles})
    get_filename_component(_filename ${_file} NAME)
    configure_file(utils/${_filename} ${SICONOS_SWIG_ROOT_DIR}/${_filename} COPYONLY)
  endforeach()

  # ====== Create (and setup) build target ======

  add_custom_target(python-build
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py build
    COMMENT "Build ${SICONOS_PYTHON_PACKAGE} package")

  IF(UNIX AND NOT APPLE)
    LIST(APPEND python_install_options "--root=$(DESTDIR)/")
  ENDIF(UNIX AND NOT APPLE)
  add_custom_target(python-install
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/setup.py install ${python_install_options}
    VERBATIM
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMENT "build/install siconos package")
  install(CODE "execute_process(COMMAND ${CMAKE_BUILD_TOOL} python-install WORKING_DIRECTORY \"${CMAKE_CURRENT_BINARY_DIR}\")")

  # ====== Create a Target to clean sources (remove .pyc files) and build dir ======

  file(GLOB_RECURSE PYCFILES "${CMAKE_SOURCE_DIR}/*.pyc")
  add_custom_target(pyclean COMMAND rm -f ${PYCFILES}
    COMMAND make clean
    COMMAND rm -rf ${CMAKE_BINARY_DIR}/build
    COMMENT "Clean sources and build.")

  # ====== conf/copy file for docstrings generation from doxygen ====
  if(WITH_DOXY2SWIG)
    configure_file(${CMAKE_SOURCE_DIR}/externals/swig/doxy2swig.py ${CMAKE_BINARY_DIR}/share/doxy2swig.py COPYONLY)
    configure_file(${CMAKE_SOURCE_DIR}/docs/sicodoxy2swig.py ${CMAKE_BINARY_DIR}/share/sicodoxy2swig.py COPYONLY)
    
  endif()

endif()

=== control/swig/CMakeLists.txt ===
#================================================================
# cmake utilities to build python-bindings for control component
#================================================================

# wrap - Set extra dependencies
set(SWIG_MODULE_${COMPONENT}_EXTRA_DEPS
  ${CMAKE_SOURCE_DIR}/kernel/swig/kernel.i
  ControlBase.i
  ControlTypemaps.i
  )

# List of modules to be built in the python bindings
set(${COMPONENT}_PYTHON_MODULES
  "${COMPONENT}/controller"
  "${COMPONENT}/observer"
  "${COMPONENT}/sensor"
  "${COMPONENT}/simulation"
)

set(${COMPONENT}_SWIG_INCLUDE_DIRECTORIES
  ${CMAKE_SOURCE_DIR}/kernel/swig)
set(${COMPONENT}_SWIG_DEFS "${SWIG_DEFS}")

include(swig_python_tools)
swig_module_setup(${COMPONENT}_PYTHON_MODULES)
if(NOT HAS_FORTRAN)
  list(APPEND ${COMPONENT}_python_excluded_tests
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/test_smc.py)
endif()
build_python_tests()

=== debian/changelog ===
siconos (4.2.0+git20181026.0ee5349+dfsg.2-2) unstable; urgency=medium

  * Patch to fix ref filename for test SMCTest::SMCLsodar.
  * Add TwistingTest::test_ExplicitTwisting_Lsodar to list of broken tests.
  * Remove compiler paths and flags in installed CMakeLists.txt.
    (Closes: #940194)
  * Update to standards version 4.5.0, no changes necessary.
  * Update to debhelper compat 12, no changes necessary.
  * d/copyright: Add Upstream-Contact field.

 -- Stephen Sinclair <radarsat1@gmail.com>  Sun, 02 Feb 2020 20:12:40 +0000

siconos (4.2.0+git20181026.0ee5349+dfsg.2-1) unstable; urgency=medium

  * Initial release. (Closes: #915656)

 -- Stephen Sinclair <radarsat1@gmail.com>  Sat, 06 Apr 2019 18:47:19 +0000

=== debian/control ===
Source: siconos
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephen Sinclair <radarsat1@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12),
               dh-python,
               cmake (>= 3.0.2),
               libhdf5-dev (>= 1.10),
               libsuitesparse-dev (>= 1:5.1.2),
               libgmp3-dev,
               swig3.0,
               libmumps-seq-dev,
               doxygen,
               graphviz,
               help2man,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               python3-sphinxcontrib.bibtex,
               python3-breathe,
               libbullet-dev,
               libboost-graph-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               liblpsolve55-dev,
               libatlas-base-dev,
               gfortran,
               libcppunit-dev,
               libfclib-dev,
               python3-lxml,
               python3-scipy,
               python3-numpy,
               python3-pytest,
               python3-vtk7,
               python3-h5py,
               python3-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/siconos
Vcs-Git: https://salsa.debian.org/science-team/siconos.git
Homepage: https://nonsmooth.gricad-pages.univ-grenoble-alpes.fr/siconos/index.html
Rules-Requires-Root: no

Package: siconos
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         cmake,
         libsiconos-numerics-dev (= ${binary:Version}),
         libsiconos-kernel-dev (= ${binary:Version}),
         libsiconos-control-dev (= ${binary:Version}),
         libsiconos-mechanics-dev (= ${binary:Version}),
         libsiconos-io-dev (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (simulation runner tool)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the 'siconos' tool allowing to compile and run
 Siconos programs/scripts in a single command.

Package: siconos-mechanics-tools
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         python3-siconos (= ${binary:Version}),
         python3-h5py (>= 2.8.0-1),
         python3-vtk7
Description: modeling and simulation of nonsmooth dynamical systems (mechanics tools)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains tools to allow running, analysing, manipulating,
 exporting, and viewing the output of mechanical simulations.

Package: libsiconos-numerics6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: modeling and simulation of nonsmooth dynamical systems (numerics lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the numerics component of
 Siconos, an interface to a collection of common numerical solvers.

Package: libsiconos-numerics-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libhdf5-dev (>= 1.10),
         libsuitesparse-dev (>= 1:5.1.2)
Description: modeling and simulation of nonsmooth dynamical systems (numerics dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the numerics
 component of Siconos, an interface to a collection of common
 numerical solvers.

Package: libsiconos-kernel6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (kernel lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the kernel component of Siconos.

Package: libsiconos-kernel-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-kernel6 (= ${binary:Version}),
         libsiconos-numerics-dev (= ${binary:Version}),
         libsuitesparse-dev (>= 1:5.1.2),
         libboost-dev (>= 1.62.0.1),
         libgmp-dev (>= 2:6.1.2+dfsg-3)
Description: modeling and simulation of nonsmooth dynamical systems (kernel dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the kernel
 component of Siconos.

Package: libsiconos-control6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libsiconos-kernel6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the control component of Siconos.

Package: libsiconos-control-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-control6 (= ${binary:Version}),
         libsiconos-kernel-dev (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the control

=== debian/rules ===
#!/usr/bin/make -f

# TODO MPI? test with GlobalFrictionalContact3D_SparseBlockStorage
# TODO doc package

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

export CCACHE_DIR := /var/tmp/ccache

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	TESTING=OFF
else
	TESTING=ON
endif

ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	CMAKE_VERBOSE_OFF=-DCMAKE_VERBOSE_MAKEFILE=OFF
endif

# These tests are failing
TESTS_TO_SKIP=\
 fc3d__NSN_AC_Tol_1e-5_Max_1000_inTol_0_inMax_0_IPARAM_1_Capsules-i100-1090 \
 fc3d__NSN_AC_TEST_Tol_1e-5_Max_1000_inTol_0_inMax_0_IPARAM_1_Capsules-i101-404 \
 fc3d__NSN_AC_TEST_Tol_1e-3_Max_1000_inTol_0_inMax_0_Capsules-i101-404 \
 fc3d__ADMM_Tol_1e-08_Max_100000_inTol_0_inMax_0_IPARAM_SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_RESIDUAL_BALANCING_LMGC_100_PR_PerioBox-i00361-60-03000.hdf5 \
 fc3d__ADMM_Tol_1e-08_Max_100000_inTol_0_inMax_0_IPARAM_SICONOS_FRICTION_3D_ADMM_RHO_STRATEGY_RESIDUAL_BALANCING_SICONOS_FRICTION_3D_ADMM_FORCED_SPARSE_STORAGE_LMGC_100_PR_PerioBox-i00361-60-03000.hdf5 \
 gfc3d__NSN_AC_Tol_0_Max_0_inTol_0_inMax_0_LMGC_GFC3D_CubeH8.hdf5 \
 gfc3d__NSN_AC_Tol_1e-14_Max_0_inTol_0_inMax_0_LMGC_GFC3D-i00501-4-00000.hdf5 \
 TwistingTest::test_ExplicitTwisting_Lsodar

BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)

# We disable parallel build because an 8 GB laptop runs out of memory
# with 4 parallel processes
%:
	dh $@ --with python3 --no-parallel --builddirectory=$(BUILDDIR)

$(BUILDDIR)/swig3.0:
	mkdir -vp $(BUILDDIR)
	ln -s $(shell which ccache-swig3.0) $(BUILDDIR)/swig3.0
	ln -s $(shell which ccache-swig3.0) $(BUILDDIR)/c++
	ln -s $(shell which ccache-swig3.0) $(BUILDDIR)/cc

# Notes: remove rpath due to Debian policy
override_dh_auto_configure: $(BUILDDIR)/swig3.0
	dh_auto_configure --                                       \
	-DCMAKE_SKIP_BUILD_RPATH=TRUE                              \
	-DFORCE_SKIP_RPATH=1                                       \
	-DCMAKE_SKIP_INSTALL_RPATH=TRUE                            \
	-DCMAKE_SKIP_RPATH=TRUE                                    \
	-DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/siconos                \
	-DPYTHON_EXECUTABLE=$(shell which python3)                 \
	-DI_WANT_STATIC_LPSOLVE=ON                                 \
	-DLpSolve_LIBRARY=/usr/lib/liblpsolve55_pic.a              \
	-DWITH_TESTING=$(TESTING)                                  \
	-DWITH_DOCUMENTATION=ON                                    \
	-DWITH_DOXY2SWIG=ON                                        \
	-DWITH_SYSTEM_SUITESPARSE=ON                               \
	-DWITH_SERIALIZATION=ON                                    \
	-DWITH_BULLET=ON                                           \
	-DWITH_FCLIB=ON                                            \
	-DWITH_OCE=OFF                                             \
	-DIDONTWANTMPI=ON                                          \
	-DWITH_MUMPS=ON                                            \
	-DSWIG_EXECUTABLE=$(BUILDDIR)/swig3.0                      \
	-DCMAKE_C_COMPILER=$(BUILDDIR)/cc                          \
	-DCMAKE_CXX_COMPILER=$(BUILDDIR)/c++                       \
	-Dpython_install_options="--install-layout=deb"            \
	$(CMAKE_VERBOSE_OFF)                                       \
	-Dtests_timeout=30

# Build ctest regular expression
null  :=
space := $(null) $(null)
or := |
TESTS_TO_SKIP := $(subst $(space),$(or),$(strip $(TESTS_TO_SKIP)))

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- ARGS="-E '$(TESTS_TO_SKIP)'"
endif

# Install software, headers, docs.
override_dh_auto_install:
# Software
	dh_auto_install

# Headers separated by component.  No headers for externals.
	for comp in numerics kernel control mechanics io; do \
	  echo installing headers for libsiconos-$${comp}-dev; \
	  ls debian/tmp/usr/include/siconos | while read file; do \
		find $${comp} -name $${file} -exec \
	      install -D -t debian/libsiconos-$${comp}-dev/usr/include/siconos {} \; ; \
	  done; \
	done

# The installed CMakeLists.txt for the `siconos` build tool contains
# inappropriate links to tools and directories found in the source or
# build dir, these lines can be safely removed and the system defaults
# will be used instead.
	grep -v -e "$(CURDIR)" -e "/usr/lib/ccache" \
	  debian/tmp/usr/share/siconos/CMakeLists.txt >tmp_CMakeLists.txt
	mv tmp_CMakeLists.txt debian/tmp/usr/share/siconos/CMakeLists.txt

# Clean swig3.0 symlink
override_dh_auto_clean:
	dh_auto_clean
	rm -fv $(BUILDDIR)/swig3.0 $(BUILDDIR)/cc $(BUILDDIR)/c++

=== debian/tests/control ===
Tests: kernel-dev
Depends: build-essential, libsiconos-kernel-dev, shunit2

Tests: numerics-tests kernel-tests control-tests
Depends: build-essential, siconos, libcppunit-dev, shunit2

Tests: kernel-tests-python, control-tests-python
Depends: python3-siconos, shunit2

Tests: mechanics-tests
Depends: build-essential, siconos, libbullet-dev, libcppunit-dev, shunit2

Tests: mechanics-tests-python
Depends: python3-siconos, shunit2

Tests: mechanics-tools
Depends: siconos-mechanics-tools, python3-vtk7, python3-scipy, file, shunit2
